/**
 * history componenet
 */
(function(host, undef){

  const MillisecondOfDay = 24 * 60 * 60 * 1000;

  function getCnWeekday(wday){
    return '日一二三四五六'[wday];
  }

  function getCnDate(date){
    return date.getFullYear() + '年'
      + (date.getMonth()+1) + '月'
      + date.getDate() + '日-'
      + '星期' + getCnWeekday(date.getDay());
  }
  function getTime(date){
    date = date || new Date;
    return date.getHours() + ':'
      + date.getMinutes() + ':'
      + date.getSeconds();
  }

  var historyApis = host.historyApis = new ChromeWebUIApis({
    methods: 'getHistory,searchHistory,removeURLsOnOneDay,clearBrowsingData,removeBookmark,getHasHistoryDays',
    onerror: function(ev){
      console.log('error:', arguments);
    },
    onbefore: function(ev){
      console.log(getTime(), 'before call:'+ev.methodName, ev.args);
    },
    onbeforeCallback: function(ev){
      console.log(getTime(), 'before callback:'+ev.methodName, ev.args);
    },
    onafterCallback: function(ev){
      console.log(getTime(), 'after callback:'+ev.methodName, ev.args);
    }
  });

  function history(opts){
    this.opts = opts || {};
    CETH.createEvents(this, history.EVENTS);
    
  }


  history.prototype = {
    render:function(items, cb){
      var opts = this.opts || {},
      sortby = typeof opts.sortby == 'function' ? opts.sortby() : opts.sortby,
      offday = typeof opts.offday == 'function' ? opts.offday() : opts.offday,
      searchtext = typeof opts.searchtext == 'function' ? opts.searchtext() : opts.searchtext,
      $stage = $(opts.stage),
      self = this,
      tmplSiteHeader = $(opts.tmplSiteHeader).html(),
      tmplHistoryItem = $(opts.tmplHistoryItem).html();

      function onReceive(obj, items){


        $stage.empty();
        var s = +new Date;

        if(sortby == 'site'){
          items = items.sort(function(a, b){
            return a.host.localeCompare(b.host);
          });
        }
        console.log('sort:',+new Date - s);

        if(searchtext){
          $stage.addClass('bysearch');
        }else{
          $stage.removeClass('bysearch');
        }

        var worker = new Worker('tmpl_worker.js');
        worker.onmessage = function(ev){
          cb ? cb(ev.data) : $stage.append(ev.data); 
          CETH.fire(self, 'AfterRender', {items:items});
        };
        worker.postMessage({
          sortby: sortby,
          searchtext: searchtext,
          tmplSiteHeader : tmplSiteHeader,
          tmplHistoryItem : tmplHistoryItem,
          items: items
        });


      }
      if(searchtext){
        historyApis.searchHistory(searchtext, '0', onReceive);
      }else{
        historyApis.getHistory(0-offday, onReceive);
      }

    }
  };
  
  history.EVENTS = 'AfterRender';
  host.His = history;

})(window);
