/**
 * history html mainjs
 */

$(function(){

  const MillisecondOfDay = 24 * 60 * 60 * 1000;
  function getCnWeekday(wday){
    return '日一二三四五六'[wday];
  }

  for(var name in $.easing){
    $('.debug-easing').append('<option>'+name+'</option>');
  }
  $('.debug-easing option:contains(easeInOutQuart)').attr('selected',true);

  String.prototype.shorting = function(len, omiss){
    omiss = omiss || '...';
    if(this.length > len){
      return (this.substr(0,len/2) + omiss + this.substr(this.length-len/2)).toString();
    }else{
      return this.toString();
    }
  }

  function htmlEncode(str){
    var tmpDiv = htmlEncode.tmpDiv = htmlEncode.tmpDiv || document.createElement('div');
    tmpDiv.textContent = str;
    return tmpDiv.innerHTML;
  }

  function getCnDate(date, config){
    config = config || {
      year: true,
      month: true,
      day: true,
      week: true
    };
    return (config.year ? date.getFullYear() + '年' : '')
      + (config.month ? (date.getMonth()+1) + '月' : '')
      + (config.day ? date.getDate() + '日' : '')
      + (config.week ? '-星期' + getCnWeekday(date.getDay()) : '');
  }

  function getHeaderDate(date){
    var nowDate = new Date(),
    strDate =  getCnDate(date);
    if(Math.floor((nowDate - MillisecondOfDay) / MillisecondOfDay) == Math.floor(date / MillisecondOfDay)){
      strDate += '<span>（今天）</span>';
    }else if(Math.floor((nowDate - MillisecondOfDay*2) / MillisecondOfDay) == Math.floor(date / MillisecondOfDay)){
      strDate += '<span>（昨天）</span>';
    }
    return strDate;
  }

  $(function(){
    $('.sortby[value='+(location.hash=='#site'?'site':'time')+']').attr('checked',true);
  });

  var historys = new His({
    sortby: function(){
      return $('.sortby:checked').val();
    },
    searchtext: function(){
      return $('#search-field').val();
    },
    offday: function(){
      return $('.scroll-area li.justcur a').attr('offDay')*1;
    },
    stage: '.content ul',
    tmplSiteHeader: '#tmplSiteHeader',
    tmplHistoryItem: '#tmplHistoryItem'
  });

  CETH.on(historys, 'AfterRender', function(e){
    $(window).trigger('resize');
    $('#clear-pages').attr('disabled', !e.items.length);
  });


  historyApis.getHasHistoryDays(60, function(obj, offDays){
    var days = {},ym;
    offDays.forEach(function(offDay){
      var date = new Date(+new Date + offDay * MillisecondOfDay);
      ym=date.getFullYear() + '-' + date.getMonth();
      if(!days[ym]){
        days[ym] = [];
      }
      days[ym].push( [date.getDate(), offDay, date] );
    });

    var h2, ol;
    calenders = $('.scrollable-sections');
    calenders.empty();
    
    for(var ym in days){
      ol = $('<ol></ol>');
      days[ym].forEach(function(dayUnion){
        var day = dayUnion[0],
        offDay = dayUnion[1],
        date = dayUnion[2],
        strDate = getCnDate(date, {
          month:true,
          day:true
        });

        ol.prepend('<li><a href="#" date="'+(ym.replace(/(\d+)$/,function($,$1){return $1*1+1})+'-'+day)+'" offday="'+offDay+'" title="'+strDate+'">'+day+'</a></li>');
      });
      calenders.prepend(ol);
      calenders.prepend('<h2><a href="#">'+(ym.replace(/\d+?-/g,'')*1+1)+'月</a></h2>');
    }
    calenders.find('ol:first').show();
    calenders.find('h2:first>a').addClass('cur');

    historyEffct();
    calenders.find('ol:first li:first a').trigger('mousedown');


    $('.browsing-header').html(getHeaderDate(new Date));

  });

  $('#search-field').live('mousedown', function(e){
    var jself = $(e.target);
    if(jself.val().length){
      setTimeout(function(){
        if(!jself.val().length){
          if(window.last_date_link){
            var lastLink = $(window.last_date_link).trigger('mousedown');
            var lastLinkAsOl = lastLink.parent().parent();
            if(!lastLinkAsOl.is(':visible')){
              lastLinkAsOl.prev().children().trigger('click');
            }
            
          }
        }
      },200);
    }
  });

  var reWheel = 0;
  $('.content').live('mousewheel', function(e){
    console.log(reWheel);
    if(e.originalEvent.wheelDeltaY>0 && this.scrollTop==0 && $('.scrollable-sections li.cur').prev().length){
      reWheel++;
      if(reWheel>10){
        $('.scrollable-sections li.cur').prev().find('a').trigger('mousedown');
        $('.content-up-suggest,.content-down-suggest').remove();
        reWheel=0;
      }
      if(!$('.content-up-suggest').length){
        $('<div/>').addClass('content-up-suggest').appendTo(this);
      }else{
        $('.content-up-suggest').css('opacity', reWheel/10).html(10-reWheel);
      }
    }else if(e.originalEvent.wheelDeltaY<0 && this.scrollTop + this.offsetHeight == this.scrollHeight){
      reWheel++;
      if(reWheel>10){
        $('.scrollable-sections li.cur').next().find('a').trigger('mousedown');
        $('.content-up-suggest,.content-down-suggest').remove();
        reWheel=0;
      }
      if(!$('.content-down-suggest').length){
        $('<div/>').addClass('content-down-suggest').appendTo(this).css({top:this.scrollHeight-130});
      }else{
        $('.content-down-suggest').css('opacity', reWheel/10).html(10-reWheel);
      }
    }else{
      reWheel = 0;
      $('.content-up-suggest,.content-down-suggest').remove();
    }
  });

  $('.scroll-area li a').live('mousedown', function(e){
    if($('.animating').length){
      return;
    }
    $('.content-up-suggest,.content-down-suggest').remove();
    window.last_date_link = e.target;
    $('.browsing-header').show();
    $('.search-header').hide();
    var fromLi = $(e.target).parents('.scroll-area').find('li.cur'),
    newLi = $(e.target).parent();


    if(fromLi.length && fromLi[0] != newLi[0] && fromLi.is(':visible') && false) {
      var proxyLi = $('<div></div>').addClass('proxy-li').appendTo(newLi.parent()),
      fromOff = fromLi.position(),
      newOff = newLi.position();
      newLi.addClass('justcur');
      fromLi.removeClass('cur').removeClass('justcur');
      proxyLi.css({left:fromOff.left, top:fromOff.top, width:fromLi.width(), height:fromLi.height()});

      setTimeout(function(){
        proxyLi.addClass('animating');
        proxyLi.on('webkitTransitionEnd', function(){
          proxyLi.remove();
          newLi.addClass('cur');
        });
        proxyLi.css({
          top:newOff.top
        });
      });

    }else{
      fromLi.removeClass('cur').removeClass('justcur');
      newLi.addClass('cur').addClass('justcur');
    }

    var strDate = $(e.target).attr('date'),
    date = new Date(Date.parse(strDate));

    strDate = getHeaderDate(date);


    $('#search-field').val('');
    historys.render();

    if(fromLi.length && fromLi[0] != newLi[0]){
      var fromDate = Date.parse(fromLi.find(':first-child').attr('date')),
      toDate = Date.parse(newLi.find(':first-child').attr('date')),
      oldContent = $('<div></div>').html($('.content').html()).addClass('content'),
      curContent = $('.content');

      var slideDistance = 20,
      ANIMATION_TIME = $('.debug-time input').val()*1 || 400,
      ANIMATION_EASING = $('.debug-easing').val(),
      ANIMATION_DIRECTION = true;

      function animationDirection(fromDate, toDate){
        if(ANIMATION_DIRECTION){
          return fromDate > toDate;
        }else{
          return fromDate < toDate;
        }
      }

      $('.browsing-header').html(strDate);

      if(animationDirection(fromDate,toDate)){
        curContent.before(oldContent);
        oldContent.css({top:0, opacity:1});
        curContent.css({top: curContent.height(),opacity:0});
        oldContent.addClass('animating');
        curContent.addClass('animating');
        
        oldContent.animate({top: -oldContent.height(),opacity:0}, ANIMATION_TIME, ANIMATION_EASING, function(){
          oldContent.remove();
        });
        curContent.animate({top: 0,opacity:1}, ANIMATION_TIME, ANIMATION_EASING, function(){
          curContent.removeClass('animating');
        });


      }else{
        curContent.after(oldContent);
        oldContent.css({top:0, opacity:1});
        curContent.css({top: -curContent.height(),opacity:0});
        oldContent.addClass('animating');
        curContent.addClass('animating');


        oldContent.animate({top: oldContent.height(),opacity:0}, ANIMATION_TIME, ANIMATION_EASING, function(){
          oldContent.remove();
        });
        curContent.animate({top: 0,opacity:1}, ANIMATION_TIME, ANIMATION_EASING, function(){
          curContent.removeClass('animating');
        });

      }
    }else{
      $('.browsing-header').html(strDate);
    }

  });

  $('.sortby').live('click', function(e){
    location.hash = e.target.value;
    historys.render();
  });


  $('.cls-btn').live('click', function(e){
    var clsBtn = this;
    if($(this).attr('time')){
      historyApis.removeURLsOnOneDay(parseInt($(this).attr('time')), $(this).attr('url'),function(){
        $(clsBtn).parents('.li-content').addClass('deleted').parent().addClass('del');
        if(!$(clsBtn).parents('ul').find('>li:not(.del)').length){
          $('#clear-pages').attr('disabled', true);
        }
      });
    }
  });
  window.deleteFailed = function(){
    console.log(arguments);
  };

  $('.cls-grp-btn').live('click', function(){
    var self = this;
    var clearTimer = setInterval(function(){
      var cles = $(self).parent().nextUntil('h2');
      cles = cles.filter(':not(.del)');
      if(cles.length){
        cles.find('.cls-btn').trigger('click');
      }else{
        $(self).parent().addClass('deleted');
        clearTimeout(clearTimer);
      }
    },50);
  });

  $('.search_this').live('click', function(e){
    var host = $(e.target).attr('host');
    $('#search-field').val(host);
    $('#search-field').removeClass('empty-text');
    $('#btn-search').trigger('click');
  });


  $('#search-field').blur(function(){
    if(this.value){
      $(this).removeClass('empty-text');
    }else{
      $(this).addClass('empty-text');
    }
  });

  $('#btn-search').live('click', function(){
    var search_text = $('#search-field').val();
    if(!search_text){
      $(window.last_date_link).trigger('mousedown');
      return;
    }
    $('.browsing-header').hide();
    $('.search-header').show();
    $('.search-header span').html("页面上包含“"+htmlEncode(search_text)+"”的网页");
    $('.scrollable-sections ol li').removeClass('cur');
    historys.render();
  });

  $('#clear-more').live('click', function(){
    historyApis.clearBrowsingData();
  });


  $('#clear-pages').live('click', function(e){
    if($('.search-header').is(':visible')){
      $('.by-search').show();
      $('.by-day').hide();
    }else{
      $('.by-search').hide();
      $('.by-day').show();
      var date = new Date(Date.parse($('.scrollable-sections .cur a').attr('date')));
      $('.rm-month').html(date.getMonth()+1);
      $('.rm-day').html(date.getDate());
    }
    $('.mask').fadeIn();
    $('#rm-confirm').show();
  });
  $('#rm-confirm .green-btn').live('click', function(){
    if($('.search-header').is(':visible')){
      var delTimer = setInterval(function(){
        var noDels = $('.li-content:not(.deleted) .cls-btn');
        if(noDels.length){
          noDels.trigger('click');
        }else{
          clearInterval(delTimer);
          $('#clear-pages').attr('disabled', true);
          $('.site-sort').addClass('deleted');
        }
      }, 50);
    }else{
      var urls = [],time;
      $('.content ul .cls-btn').each(function(idx,item){
        urls.push($(item).attr('url'));
        time=$(item).attr('time');
      });
      historyApis.removeURLsOnOneDay.apply(historyApis,[parseInt(time)].concat(urls).concat(function(){
        $('.content ul .li-content').each(function(idx,item){
          $(item).addClass('deleted');
        });
        $('#rm-confirm').hide();
        $('.mask').fadeOut();
        $('#clear-pages').attr('disabled', true);
        $('.site-sort').addClass('deleted');
      }));
    }

  });

  $('#rm-confirm .gray-btn, #rm-confirm .btn-close').live('click', function(){
    $('#rm-confirm').hide();
    $('.mask').fadeOut();
  });

  $(document).live('click', function(e){
    if(!$(e.target).parents('#rm-confirm').length && e.target.id != 'clear-pages'){
      $('#rm-confirm').hide();
      $('.mask').fadeOut();
    }else{
      e.preventDefault();
      e.stopPropagation();
    }
  });

  $('.scroll-area').live('contextmenu', function(e){
    e.preventDefault();
  });

  $('a[href=#]').live('click', function(e){
    e.preventDefault();
  });
});
function historyEffct(){
  var active,$h2A = $('.scroll-area').find('h2 a');
  $(window).resize(function(){
    var $win = $(this),
      $header = $('header'),
      $scrollArea = $('.scroll-area'),
      $scrollableSections =$scrollArea.children(), 
      $content = $('.content-wrap'),
      $topShadow = $('#scrollable-sections-top-shadow'),
      $bottomShadow = $('#scrollable-sections-bottom-shadow'),
      winH = $win.height(),
      headerH = $header.outerHeight(true),
      scrollAreaH = $scrollArea.outerHeight(true),
      contentH = $content.outerHeight(true),
      scrollableSectionsH = $scrollableSections.height(),
      scollableH = scrollableSectionsH-(winH-headerH-20),
      sclVal,
      shadowVal;
    scrollAreaH > winH-headerH ? $scrollArea.css({'height':winH-headerH-10}) && $content.css({'height':winH-headerH-10}):$scrollArea.css({'height':winH-headerH-10})&&$content.css({'height':winH-headerH-10});

      $scrollArea.scroll(function(){ 
        if( !active ){
          active = true;
          sclVal = $(this).scrollTop();
          shadowVal = sclVal/scollableH;
          $topShadow.css({'opacity':shadowVal});
          $bottomShadow.css({'opacity':1-shadowVal});
          active = false;
        }
      });

  }).trigger("resize");

  $h2A.click(function(e){
    if( !active ){
      active = true;

      var self = this;

      $(this).toggleClass('cur').parent().siblings('h2').children().removeClass('cur');
      $(this).parent().next('ol').slideToggle(function(){
        active = false;
      }).siblings('ol').slideUp(function(){

        $(self).parents('.scroll-area').animate(
          {scrollTop: self.parentNode.offsetTop});
      });


      return false;
    }
    
  }); 
}
