$ = function (selector) {
    if (selector.substr(0, 1) == '#') {
        return document.getElementById(selector.substr(1, selector.length));
    } else {
        return document.getElementsByTagName(selector);
    }
};

var Event =
{
    p_: window,
    click: function (obj) {
        if (document.all) {
            obj.click();
        } else {
            var evt = document.createEvent("MouseEvents");
            evt.initEvent("click", true, true);
            obj.dispatchEvent(evt);
        }
    },
    util_event: function (e, obj) {
        e.element = obj;
        if (!e.preventDefault) {
            e.preventDefault = function () {
                e.returnValue = false;
            }
        }
        if (!e.stop) {
            e.stopPropagation = function () {
                e.cancelBubble = true;
            }
        }
        return e;
    },
    proxy: function (func, obj) {
        var that = this;
        return function () {
            arguments[0] = that.util_event(arguments[0], obj);
            func.apply(Event.p_, arguments);
        }
    },
    bind: function (obj, event, func) {
        if (obj.length > 0) {
            for (var i = 0; i < obj.length; i++) {
                this.bind(obj[i], event, func);
            }
            return;
        }
        if (obj.addEventListener) {
            obj.addEventListener(event, this.proxy(func, obj), false);
        }
        else if (obj.attachEvent) {
            obj.attachEvent('on' + event, this.proxy(func, obj));
        }
    },
    load: function (cb) {
        var already = false;
        if (document.addEventListener) {
            already = true;
            this.bind(document, "DOMContentLoaded", cb);
        }
        else if (document.all && !window.opera) {
            document.write('<script type="text/javascript" id="content_loaded" defer="defer" src="javascript:void(0)"><\/script>');
            var content_loaded = document.getElementById("content_loaded")
            content_loaded.onreadystatechange = function () {
                if (this.readyState == "complete") {
                    already = true;
                    cb();
                }
            };
        }
        this.bind(window, 'load', function () {
            setTimeout(function () { if (!already) cb(); }, 0);
        });
    }
}
Stats = {
    securityId: (function () {
        try {
            return external.twGetSecurityID(window);
        } catch (e) { }
        return false;
    })(),
    add: function (index) {
        if (this.securityId)
            external.StatAddValue(this.securityId, "navigator_error", index, 1);
    }
};
var Error = {};
Error.info =
{
    parse: function () {
      var pattern = /url=([^&]*?)&error=(.+)$/i;
      if(pattern.test(location.href)){
        this._error_url = unescape(RegExp.$1);
        this._error_type = RegExp.$2;
        var newEl = document.createElement('a');
        newEl.href = this._error_url;
        if (newEl.protocol == 'javascript:' || newEl.protocol == 'data:') {
          this._error_url = '';
        }
        var urls = this._error_url.split("/");
        this._error_domain = urls[2];
        if(this._error_type.indexOf('http') == 0){
          this._error_code = parseInt(this._error_type.replace('http',''));
          if(this._error_type != 'http404'){
            this._error_type = 'default';
          }
        }
      }
    },
};
Error.layout = {
    render: function (error_type) {
        this['_render_' + error_type]();
    },
    _render_default: function () {
        Stats.add(4); // 4. 其他错误页展示次数
        document.title = "糟糕！网页无法访问。";
        this._render_include();
        $('#s_network').style.display = 'none';
        $('#s_default').style.display = 'none';
        $('#h_notfound').style.display = 'none';
        // 默认显示错误码
        if(Error.info._error_code>0)
          $('#error_type').innerHTML = Error.info._error_code;
        else
          $('#error_type').innerHTML = "网络错误";

        $('#button_back').style.display = 'none';
        $('#button_index').style.display = 'none';

        // 初始化搜索框内容
        $('#search_keyword').value = 'site:' + Error.info._error_domain + ' ';
        $('#search-results').src = 'http://www.so.com/brw?u=http://'+Error.info._error_domain;
    },
    _render_connectionfailure: function () {
        Stats.add(1); // 1.资源不存在错误页展示次数
        document.title = "糟糕！网页无法访问。";
        this._render_include();
        $('#s_default').style.display = 'none';
        $('#s_notfound').style.display = 'none';
        $('#h_notfound').style.display = 'none';
        // 网络错误
        //            $('#error_type').innerHTML = Error.info.__error_code;
        $('#error_type').innerHTML = "连接错误";
        // 初始化搜索框内容
        $('#search_keyword').value = Error.info._error_domain;

        $('#button_back').style.display = 'none';
        $('#button_index').style.display = 'none';
    },
    _render_http404: function () {
        Stats.add(3); // 3. 404 错误也展示次数
        document.title = "您访问的网页不存在。";
        this._render_include();
        $('#s_notfound').style.display = 'none';
        $('#s_network').style.display = 'none';
        $('#h_default').style.display = 'none';
        $('#button_refresh').style.display = 'none';

        // 初始化搜索框内容
        $('#search_keyword').value = 'site:' + Error.info._error_domain + ' ';
    },
    _render_include: function () {

        // 点击搜索右侧下拉箭头
        Event.bind($('#button_slist'), 'click', function (e) {
            e.preventDefault();
            e.stopPropagation();
            var obj = $('#search_droplist');
            if (obj.style.display == 'block') {
                obj.style.display = 'none';
            }
            else {
                obj.style.display = 'block';
            }

        });
        // 点击页面任意位置隐藏下拉菜单
        Event.bind($('body'), 'click', function (e) {
            $('#search_droplist').style.display = 'none';
        });
        // 搜索下拉菜单项
        Event.bind($('#search_droplist').getElementsByTagName('a'), 'click', function (e) {
            e.preventDefault();
            var obj = $('#search_form');
            obj.setAttribute('action', e.element.getAttribute('rel', 2));
            $('#search_keyword').setAttribute('name', e.element.getAttribute('key'));
            var v = e.element.innerHTML.replace(/<[^>]+>|\n|\r/g, '');
            $('#button_search').value = v;
            try {
                var sid = external.twGetSecurityID(window);
                external.SetOptionValue(sid, "haostorage", "default_search_naverr", e.element.className);
            } catch (e) { }
        });

        var cls = false;
        try {
            var sid = external.twGetSecurityID(window);
            cls = external.GetOptionValue(sid, "haostorage", "default_search_naverr") || false;
        } catch (e) { }
        if (cls) { // 若找到记忆位置
            var as = $('#search_droplist').getElementsByTagName('a');
            for (var i = 0; i < as.length; i++) {
                if (as[i].className == cls) Event.click(as[i]);
            }
        } else { // 默认选择第一项
            Event.click($('#search_droplist').getElementsByTagName('a')[0]);
        }
        var stats_search_modified = false;
        // 执行搜索动作
        Event.bind($('#search_form'), 'submit', function (e) {
            e.preventDefault();
            if (stats_search_modified) {
                Stats.add(12); // 12. 修改后点击搜索
            } else {
                Stats.add(11); // 11. 直接点击搜索
            }
        });
        // 点击搜索框
        Event.bind($('#search_keyword'), 'click', function (e) {
            e.element.className = 'focused';
            // e.element.select();
        });
        Event.bind($('#search_keyword'), 'keyup', function (e) {
            stats_search_modified = true;
            var k = e ? (e.charCode || e.keyCode) : 0;
            if (k == 13) {
                Event.click($('#button_search'));
            }
        });

        // 刷新按钮
        Event.bind($('#button_refresh'), 'click', function (e) {
            Stats.add(5); // 5. 点击刷新按钮次数
            e.preventDefault();
            window.location = Error.info._error_url;
        });
        // 后退按钮
        if (history.length > 2) {
            Event.bind($('#button_back'), 'click', function (e) {
                e.preventDefault();
                Stats.add(8);
                history.go(-2);
            });
        } else {
            $('#button_back').className = 'close-btn';
            $('#button_back').style.display = 'none';
            Event.bind($('#button_back'), 'click', function (e) {
                Stats.add(9);
                window.close(); // 无法后退时，显示关闭按钮
                e.preventDefault();
            });
        }

        // 去首页按钮
        Event.bind($('#button_index'), 'click', function (e) {
            e.preventDefault();
            Stats.add(10);
            window.location = "http://" + Error.info._error_domain
        });
        //  急救箱按钮
        Event.bind($('#button_network'), 'click', function (e) {
            e.preventDefault();
            Stats.add(7);
            var started = false;
            try {
                chrome.send('show_network_rescuer');
            } catch (e) { }
        });

        $('#error_default').style.display = 'block';


        

        $('#hide-search-results').onclick = function(e){
          if($('#search-results').offsetHeight){
            $('#search-results').style.display = 'none';
            e.target.innerHTML = '显示搜索结果';
            localStorage.hideSearchStatus = 1;
          }else{
            $('#search-results').style.display = 'block';
            e.target.innerHTML = '隐藏搜索结果';
            localStorage.hideSearchStatus = 0;
          }
          e.preventDefault();
        };
    },
    refresh_frame: function () {
        return;
    }
};

Event.p_ = Error;
Event.load(function () {
    try {
        Error.info.parse();
    } catch (e) {
        return;
    }
    window.initSearchBlock = function(errorType){
      return function(){
        if(errorType != 'connectionfailure'){
          $('#search-results-wrap').style.display = 'block';

          if(localStorage.hideSearchStatus == '1'){
            $('#search-results').style.display = 'none';
            $('#hide-search-results').innerHTML = '显示搜索结果';
          }else{
            $('#search-results').style.display = 'block';
            $('#hide-search-results').innerHTML = '隐藏搜索结果';
          }
        }
      };
    }(Error.info._error_type);

    if(Error.info._error_type == 'dnserror'){
      Error.info._error_type = 'connectionfailure';
    }

    Error.layout.render(Error.info._error_type);
    // Error.layout.refresh_frame();

	chrome.send('check_show_network_rescuer_button');
    
    var sct = document.createElement('script');
    sct.src = 'http://errsug.se.360.cn/errsug6s.js?'+(+new Date());
    document.body.appendChild(sct);

});

function showNetworkRescuerButton() {
    $('#button_network').style.display = '';
}
